clear variables;close all;clc

key % load API key

Questions={'De functie f wordt voor x > 0 gegeven door f(x) = 2x + 1/x. De functie f heeft een minimum. Bereken exact dit minimum.' % 1
    'De functie f wordt voor x > 0 gegeven door f(x) = 2x + 1/x. Lijn k is de scheve asymptoot van de grafiek van f. Het vlakdeel V wordt ingesloten door de grafiek van f, lijn k en de lijnen met vergelijking x = a en x = 2a met a > 0. De oppervlakte van dit vlakdeel is onafhankelijk van de waarde van a. Bewijs dit.' % 2
    'De functie f wordt voor x > 0 gegeven door f(x) = 2x + 1/x. Verder is gegeven de lijn met vergelijking y = 3. Deze lijn en de gradiek van f sluiten een vlakdeel W in dat wordt gewenteld om de lijn met vergelijking y = 3. Bereken de inhoud van het omwentelingslichaam dat zo ontstaat. Geef je eindantwoord in twee decimalen.' % 3

    'In de werktuigbouw moeten vaak metalen platen in een bepaalde hoek worden gebogen. Een van de technieken die daarbij worden gebruikt is vrijbuigen. Daarbij ligt de metalen plaat op een matrijs met een bepaalde vorm. Hierna wordt een stempel met kracht op de plaat gedrukt, zodat deze de gewenste vorm krijgt. Tijdens het vrijbuigen treedt vervorming op: aan de buitenkant rekt het metaal iets op en aan de binnenkant wordt het samengedrukt. In het inwendige van de metalen plaat bevindt zich de neutrale lijn: de lengte hiervan blijft gelijk na vervorming. In deze opgave nemen we aan dat de dikte van de plaat bij het buigen gelijk blijft. Wanneer de plaat wordt gebogen over een hoek van 45°, verandert rechthoek ABCD in de vorm A''B''C''D''. Hierbij is boog C''D'' de boog van een cirkel met middelpunt M en straal 2d en A''B'' de boog van een cirkel met middelpunt M en straal 3d. De neutrale lijn P''Q'' is een cirkelboog op een afstand van 0,4d van boog C''D''. Verder geldt dat de lengte van de neutrale lijn gelijk blijft, dus de lengte van boog P''Q'' is gelijk aan de lengte van PQ. Bereken algebraïsch hoeveel procent de oppervlakte van vlakdeel A''B''C''D'' groter is dan de oppervlakte van vlakdeel ABCD. Geef je eindantwoord als geheel getal.' % 4
    'In de werktuigbouw moeten vaak metalen platen in een bepaalde hoek worden gebogen. Een van de technieken die daarbij worden gebruikt is vrijbuigen. Daarbij ligt de metalen plaat op een matrijs met een bepaalde vorm. Hierna wordt een stempel met kracht op de plaat gedrukt, zodat deze de gewenste vorm krijgt. De kracht die uitgeoefend moet worden op een metalen plaat om deze te buigen, hangt af van het soort metaal, de dikte van het metaal en de breedte van de opening van de matrijs. De formule om deze kracht uit te rekenen luidt: F = (R*d^2/V) * (1+4d/V) (formule 1). Hierbij is: F de benodigde kracht (in kN/m); R een constante die afhangt van het soort metaal; d de dikte van het metaal (in mm); V de breedte van de opening van de matrijs (in mm). Voor het buigen van een metalen plaat met een dikte van 10 mm op een matrijs met een opening van 200 mm is een kracht van 420 kN/m nodig. Als je deze metalen plaat zou buigen op een matrijs met een opening van 100 mm is meer kracht nodig. Bereken algebraïsch hoeveel kracht er nodig is om deze metalen plaat te buigen op een matrijs met een opening van 100 mm breed. Geef je eindantwoord als een geheel getal.' % 5
    'In de werktuigbouw moeten vaak metalen platen in een bepaalde hoek worden gebogen. Een van de technieken die daarbij worden gebruikt is vrijbuigen. Daarbij ligt de metalen plaat op een matrijs met een bepaalde vorm. Hierna wordt een stempel met kracht op de plaat gedrukt, zodat deze de gewenste vorm krijgt. De kracht die uitgeoefend moet worden op een metalen plaat om deze te buigen, hangt af van het soort metaal, de dikte van het metaal en de breedte van de opening van de matrijs. De formule om deze kracht uit te rekenen luidt: F = (R*d^2/V) * (1+4d/V) (formule 1). Hierbij is: F de benodigde kracht (in kN/m); R een constante die afhangt van het soort metaal; d de dikte van het metaal (in mm); V de breedte van de opening van de matrijs (in mm). Om bij een gegeven plaatdikte de breedte van de opening van de matrijs te berekenen, wordt de volgende formule gebruikt: V =  d^1,75 (formule 2). Door formule 1 en formule 2 te combineren krijg je een formule die de benodigde kracht F uitdrukt in R en d. Er is een plaatdikte d waarbij de benodigde kracht F minimaal is. Bereken exact deze waarde van d.' % 6

    'De bewegingsvergelijkingen van een punt P worden gegeven door: x_P(t) = 2t, y_P(t) = 2t^2. Punt M is het midden van lijnstuk OP. Vector MP wordt rechtsom geroteerd om M over 90°. Zo ontstaat de beeldvector MQ. Tijdens de beweging van P beschrijft ook het punt Q een baan. De bewegingsvergelijkingen van Q worden gegeven door: x_Q(t) = t + t^2, y_Q(t) = t^2 - t. Bewijs dat dit inderdaad de bewegingsvergelijkingen van Q zijn.' % 7
    'De bewegingsvergelijkingen van een punt P worden gegeven door: x_P(t) = 2t, y_P(t) = 2t^2. Punt M is het midden van lijnstuk OP. Vector MP wordt rechtsom geroteerd om M over 90°. Zo ontstaat de beeldvector MQ. Tijdens de beweging van P beschrijft ook het punt Q een baan. De bewegingsvergelijkingen van Q worden gegeven door: x_Q(t) = t + t^2, y_Q(t) = t^2 - t. De snelheid waarmee P beweegt, is gegeven door sqrt(4 + 16t^2) . Voor elke waarde van t is deze snelheid een factor c keer zo groot als de snelheid van Q. Bereken exact de waarde van c.' % 8
    'De bewegingsvergelijkingen van een punt P worden gegeven door: x_P(t) = 2t, y_P(t) = 2t^2. Punt M is het midden van lijnstuk OP. Vector MP wordt rechtsom geroteerd om M over 90°. Zo ontstaat de beeldvector MQ. Tijdens de beweging van P beschrijft ook het punt Q een baan. De bewegingsvergelijkingen van Q worden gegeven door: x_Q(t) = t + t^2, y_Q(t) = t^2 - t. De snelheid waarmee P beweegt, is gegeven door sqrt(4 + 16t^2) . Voor elke waarde van t wordt de lengte L van lijnstuk PQ bepaald. Er geldt: L = |t| * sqrt(2t^2 + 2). Bewijs dit.' % 9
    'De bewegingsvergelijkingen van een punt P worden gegeven door: x_P(t) = 2t, y_P(t) = 2t^2. Punt M is het midden van lijnstuk OP. Vector MP wordt rechtsom geroteerd om M over 90°. Zo ontstaat de beeldvector MQ. Tijdens de beweging van P beschrijft ook het punt Q een baan. De bewegingsvergelijkingen van Q worden gegeven door: x_Q(t) = t + t^2, y_Q(t) = t^2 - t. De snelheid waarmee P beweegt, is gegeven door sqrt(4 + 16t^2) . Voor elke waarde van t wordt de lengte L van lijnstuk PQ bepaald. Er geldt: L = |t| * sqrt(2t^2 + 2). In de oorsprong, bij t = 0 , zien we een knik. Als t vanaf links of vanaf rechts tot 0 nadert, nadert de waarde van L in beide situaties ook tot 0. De helling van de grafiek van L nadert echter niet in beide situaties tot dezelfde waarde. Bereken exact tot welke waarde de helling van de grafiek van L nadert als t vanaf links tot 0 nadert.' % 10

    'De functie f wordt gegeven door f(x) = abs(sin(x) + 1/2*sqrt(3)). A en B zijn de toppen die horen bij de eerste twee maxima van f rechts van de y-as. Er bestaat een sinusoïde die gegeven wordt door g(x) = a + bsin(x), waarvan twee opeenvolgende toppen samenvallen met de punten A en B. Bereken exact de waarde van a and b.' % 11
    'De functie f wordt gegeven door f(x) = abs(sin(x) + 1/2*sqrt(3)). De grafiek van f en de x-as sluiten twee soorten vlakdelen in: kleine vlakdelen en grote vlakdelen. Bereken exact de oppervlakte van een enkel klein vlakdeel.' % 12

    'De functie f wordt gegeven door: f(x) = ln(x). De functie g wordt gegeven door: g(x) = 1 + e^2 * (1-ln(x)). De raaklijnen aan de grafieken van f en g snijden elkaar loodrecht in het snijpunt. Bewijs dit' % 13
    'De functie f wordt gegeven door: f(x) = ln(x). De functie g wordt gegeven door: g(x) = 1 + e^2 * (1-ln(x)). De lijn y = q snijdt de grafiek van g in punt A en de grafiek van f in punt B,  waarbij punt A links van punt B ligt. Er geldt dat AB = 3. Bereken de bijbehorende waarde van q. Geef je eindantwoord in één decimaal.' % 14

    'Gegeven is rechthoek OABC met O(0,0), A(8,0) en C(0,4). De punten F en E zijn de middens van respectievelijk OA en BC. Op de negatieve y-as ligt punt P(0, p). Punt D is het snijpunt van het verlengde van lijnstuk PF en lijnstuk AC. De lijn door E en F is de bissectrice van hoek PED. Bewijs dit voor het geval p = -2.' % 15
    'Gegeven is rechthoek OABC met O(0,0), A(8,0) en C(0,4). De punten F en E zijn de middens van respectievelijk OA en BC. Op de negatieve y-as ligt punt P(0, p). Punt D is het snijpunt van het verlengde van lijnstuk PF en lijnstuk AC. De lijn door E en F is de bissectrice van hoek PED. M(4, 2) is het snijpunt van AC en EF. Cirkel c heeft middelpunt M en gaat door D. Afhankelijk van de positie van punt P (en dus van de waarde van p) is de cirkel groter of kleiner. Er is precies één waarde van p waarvoor cirkel c raakt aan OA en BC. Bereken exact deze waarde van p.' % 16

    'De functie f wordt gegeven door f(x) = 1/(e^x + 1). De grafiek van f heeft twee horizontale asymptoten. Bereken exact de afstand tussen deze twee horizontale asymptoten.' % 17
    'De functie f wordt gegeven door f(x) = 1/(e^x + 1). Een primitieve van f is F(x) = x - ln(e^x + 1). Bewijs dit.' % 18
    'De functie f wordt gegeven door f(x) = 1/(e^x + 1). Lijn k heeft vergelijking x = a, met a > 0. De grafiek van f, de x-as, de y-as en lijn k sluiten een vlakdeel in. De oppervlakte van dit vlakdeel is voor elke waarde van a kleiner dan ln(2). Bewijs dit.'}; % 19

for m = 1:2 % model type
    for q = 1:19 % loop over questions
        import matlab.net.* matlab.net.http.* matlab.net.http.io.*

        header = [HeaderField('Content-Type', 'application/json');HeaderField('Authorization', api_key)]';
        uri = URI('https://api.openai.com/v1/chat/completions');

        prompt = Questions(q);
        if m==1 % o1-preview
            body = JSONProvider(struct('model', 'o1-preview-2024-09-12','messages', {{struct('role', 'user','content', prompt')}}));
        elseif m==2 % gpt-4o
            body = JSONProvider(struct('model', 'gpt-4o-2024-05-13','messages', {{struct('role', 'user','content', prompt')}}));
        end

        tic % saves the current time that 'toc' uses later to measure the time elapsed between the two.
        response = RequestMessage('post', header, body).send(uri.EncodedURI);

        disp(['QUESTION NUMBER: ' num2str(q)])
        disp(['MODEL NUMBER: ' num2str(m)])
        disp('TOKEN USAGE:')
        disp([response.Body.Data.usage.prompt_tokens ...
            response.Body.Data.usage.completion_tokens ...
            response.Body.Data.usage.total_tokens ...
            response.Body.Data.usage.completion_tokens_details.reasoning_tokens])
        disp(['TIME TAKEN: ' num2str(toc) ' seconds'])
        disp('OUTPUT:')
        disp(response.Body.Data.choices.message.content);
    end
end
